CREATE TABLE IF NOT EXISTS `nodes` (
    `nodeID` int(10) unsigned NOT NULL auto_increment,
    `text` longtext NOT NULL,
    `type` varchar(2) NOT NULL,
    `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
    PRIMARY KEY  (`nodeID`)
);

CREATE TABLE IF NOT EXISTS `edges` (
    `edgeID` int(10) unsigned NOT NULL auto_increment,
    `fromID` int(10) unsigned NOT NULL references nodes (nodeID),
    `toID` int(10) unsigned NOT NULL references nodes (nodeID),
    PRIMARY KEY  (`edgeID`)
);

CREATE TABLE IF NOT EXISTS `schemeForms` (
    `schemeFormID` int(10) unsigned NOT NULL auto_increment,
    `name` varchar(64) NOT NULL,
    `type` varchar(64) NOT NULL,
    PRIMARY KEY  (`schemeFormID`)
);

CREATE TABLE IF NOT EXISTS `descriptors` (
    `descriptorID` int(10) unsigned NOT NULL auto_increment,
    `text` varchar(64) NOT NULL,
    PRIMARY KEY  (`descriptorID`)
);

CREATE TABLE IF NOT EXISTS `schemeDescriptorLink` (
    `schemeDescriptorLinkID` int(10) unsigned NOT NULL auto_increment,
    `schemeFormID` int(10) unsigned NOT NULL references schemeForms (schemeFormID),
    `schemeScheme` BOOL NOT NULL,
    `descriptorID` int(10) unsigned references descriptors (descriptorID),
    `descriptorType` varchar(32) NOT NULL,
    `schemeTarget` int(10) unsigned references schemeForms (schemeFormID),
    PRIMARY KEY  (`schemeDescriptorLinkID`)
);

CREATE TABLE IF NOT EXISTS `descriptorFulfillment` (
    `nodeID` int(10) unsigned NOT NULL references nodes (nodeID),
    `descriptorID` int(10) unsigned NOT NULL references descriptors (descriptorID),
    PRIMARY KEY  (`nodeID`, `descriptorID`)
);

CREATE TABLE IF NOT EXISTS `schemeFulfillment` (
    `nodeID` int(10) unsigned NOT NULL references nodes (nodeID),
    `schemeFormID` int(10) unsigned NOT NULL references schemeForms (schemeFormID),
    PRIMARY KEY  (`nodeID`, `schemeFormID`)
);


CREATE TABLE nodeSets (
  nodeSetID int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (nodeSetID)
);

CREATE TABLE nodeSetMappings (
  nodeID int(10) unsigned NOT NULL references nodes (nodeID),
  nodeSetID int(10) unsigned NOT NULL references nodeSets (nodeSetID),
  PRIMARY KEY  (nodeID,nodeSetID)
);
